
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>


enum {
	_xtlfreq = 20_000_000,
	_clkfreq = 200_000_000,
	DOWNLOAD_BAUD = 230_400,
	DEBUG_BAUD = DOWNLOAD_BAUD,

};


static uint32_t  randfill( uint32_t *addr, size_t size )
{
	uint32_t  ticks;

	size >>= 2;
	ticks = _cnt();
	do {
		*(addr++) = _rnd();
	} while( --size );

	return( _cnt() - ticks );
}


static int  compare( uint32_t *addr1, uint32_t *addr2, size_t size )
{
	uint32_t  pass = 1;

	size >>= 2;
	do {
		if( *(addr1++) != *(addr2++) )  pass = 0;
	} while( --size );

	return( pass );
}


//===================================================================================

void  main( void )
{
	uint32_t  data1[50000];
	uint32_t  data2[50000];
	FILE  *fh;
	uint32_t  ticks;

	printf( " clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode() );
	printf( " Randfill ticks = %d\n", randfill( data1, sizeof(data1) ) );

	printf( " Mounting: " );
	mount( "/sd", _vfs_open_sdcard() );

	if( fh = fopen( "/sd/speed2.bin", "w" ) )
	{
		ticks = _getms();
		fwrite( data1, 1, sizeof(data1), fh );
		fclose( fh );
		ticks = _getms() - ticks;
		printf( " Writing %u bytes at %u kB/s\n", sizeof(data1), (sizeof(data1) * 1000 / ticks + 512) >> 10 );
	} else  printf( " SD card write error!\n" );

	if( fh = fopen( "/sd/speed2.bin", "r" ) )
	{
		ticks = _getms();
		fread( data2, 1, sizeof(data2), fh );
		fclose( fh );
		ticks = _getms() - ticks;
		printf( " Reading %u bytes at %u kB/s\n", sizeof(data2), (sizeof(data2) * 1000 / ticks + 512) >> 10 );
		if( compare( data1, data2, sizeof(data2) ) )  printf( " Matches!  :)\n" );
		else    printf( " Mis-matches!  :(\n" );
	} else  printf( " SD card read error!\n" );
}

